<?php
/**
* 2007-2016 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    PrestaShop SA <contact@prestashop.com>
*  @copyright 2007-2016 PrestaShop SA
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

class Hits extends ObjectModel
{
	public $id_producthits;
	public $id_product;
	public $hits;
	
	public static $definition = array(
		'table' => 'producthits',
		'primary' => 'id_producthits',
		'multilang' => false,
		'fields' => array(
			'id_product' => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedInt'),
			'hits' => array('type' => self::TYPE_INT),
		),
	);

	public static function checkPreExist($id)
	{
		$result = Db::getInstance(_PS_USE_SQL_SLAVE_)->getRow('
		SELECT `hits`
		FROM `'._DB_PREFIX_.'producthits`
		WHERE `id_product` = '.(int)$id);
		return $result['hits'];
	}

	public function insertNewEntry($id)
	{
		return Db::getInstance()->execute('
		INSERT INTO '._DB_PREFIX_.'producthits (`id_product`, `hits`)
		VALUES('.(int)$id.', 1)
		');
	}

	public function UpdateEntry($id, $value)
	{
		$value = $value + 1;
		$sql = 'UPDATE `'._DB_PREFIX_.'producthits`
			SET `hits` = '.(int)$value.'
			WHERE `id_product` = '.(int)$id;
		return Db::getInstance()->execute($sql);
	}
}