<?php
/**
 * Product Hits
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 *
 * @category  front_office_features
 * @package   producthits
 * @author    PrestaToolkit
 * @copyright Copyright 2016 © xxx All right reserved
 * @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

if (!defined('_PS_VERSION_'))
exit;
include_once(dirname(__FILE__).'/model/HitsModel.php');

class ProductHits extends Module
{
	public function __construct()
	{
	$this->name = 'producthits';
	$this->tab = 'front_office_features';
	$this->version = '1.0.0';
	$this->author = 'PrestaToolkit';
	$this->bootstrap = true;
	parent::__construct();
	$this->displayName = $this->l('Product Hits');
	$this->description = $this->l('Show hits on product page.');
	$this->tabClass = 'AdminProductHits';
	}

	public function install()
	{
		return (parent::install()
			&& $this->installDb()
			&& $this->installTab()
			&& $this->registerHook('displayBackOfficeHeader')
			&& $this->registerHook('displayProductButtons')
			);
	}

	public function installDb()
	{
		$return = true;
		$return = Db::getInstance()->execute('CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'producthits` (
				`id_producthits` int(10) NOT NULL auto_increment,
				`id_product` int(10) NOT NULL,
				`hits` int(10) NOT NULL,
				PRIMARY KEY (`id_producthits`)
			) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;');
		return $return;
	}

	private function installTab()
	{
		$tab = new Tab();
		$tab->class_name = $this->tabClass;
		$tab->id_parent = 0;
		$tab->module = $this->name;
		$tab->name[(int)(Configuration::get('PS_LANG_DEFAULT'))] = $this->l('Product Hits');
		$tab->add();
		if (_PS_VERSION_ < '1.6.0' || _PS_VERSION_ < '1.6.0.0')
		{
			$subtab = new Tab();
			$subtab->class_name = $this->tabClass;
			$subtab->id_parent = Tab::getIdFromClassName($this->tabClass);
			$subtab->module = $this->name;
			$subtab->name[(int)(Configuration::get('PS_LANG_DEFAULT'))] = $this->l('Product Hits');
			$subtab->add();
		}
		return true;
	}

	public function uninstallTab()
	{
		$id_tab = (int)Tab::getIdFromClassName('AdminProductHits');
		if ($id_tab)
		{
			$tab = new Tab($id_tab);
			return $tab->delete();
		}
		else
			return true;
	}

	public function uninstall()
	{
		return ($this->uninstallDB() && parent::uninstall() && $this->uninstallTab());
	}

	public function uninstallDB()
	{
		return (Db::getInstance()->execute('DROP TABLE IF EXISTS `'._DB_PREFIX_.'producthits`'));
	}
	
	public function getContent()
	{
		return $html = '<div class="panel" style="text-align:center"><a target="_blank" href="http://addons.prestashop.com/en/2_community-developer?contributor=360202"><img src="'.$this->_path.'views/img/banner.jpg"></a></div>';
	}

	public function hookDisplayBackOfficeHeader()
	{
		$this->context->controller->addCSS($this->_path.'views/css/admin.css');
	}
	
	public function hookDisplayProductButtons()
	{
		$id_product = (int)Tools::getValue('id_product');
		$class = new Hits;
		$pre = (int)$class->checkPreExist($id_product);
		if ($pre <= 0)
			$class->insertNewEntry($id_product);
		else
			$class->UpdateEntry($id_product, $pre);
		$this->context->smarty->assign(array(
			'hits_count' => $pre,
			'img_fire' => '<img src="'.$this->_path.'views/img/fire.png" style="width:auto;background:transparent;">'
		));
		return $this->display(__FILE__, 'hook.tpl');
	}
}